diff --git a/gdb/testsuite/gdb.go/chan.exp b/gdb/testsuite/gdb.go/chan.exp
index 2281ede820..d3799d5414 100644
--- a/gdb/testsuite/gdb.go/chan.exp
+++ b/gdb/testsuite/gdb.go/chan.exp
@@ -21,6 +21,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/handcall.exp b/gdb/testsuite/gdb.go/handcall.exp
index 360f35155c..0ae2e606bf 100644
--- a/gdb/testsuite/gdb.go/handcall.exp
+++ b/gdb/testsuite/gdb.go/handcall.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/hello.exp b/gdb/testsuite/gdb.go/hello.exp
index 1096f6475b..e2ed54a93a 100644
--- a/gdb/testsuite/gdb.go/hello.exp
+++ b/gdb/testsuite/gdb.go/hello.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/integers.exp b/gdb/testsuite/gdb.go/integers.exp
index efd3358235..7d567dbf19 100644
--- a/gdb/testsuite/gdb.go/integers.exp
+++ b/gdb/testsuite/gdb.go/integers.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/max-depth.exp b/gdb/testsuite/gdb.go/max-depth.exp
index 7fef984767..82879ce2fc 100644
--- a/gdb/testsuite/gdb.go/max-depth.exp
+++ b/gdb/testsuite/gdb.go/max-depth.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/methods.exp b/gdb/testsuite/gdb.go/methods.exp
index 0d23a69f3d..e698cf378f 100644
--- a/gdb/testsuite/gdb.go/methods.exp
+++ b/gdb/testsuite/gdb.go/methods.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/package.exp b/gdb/testsuite/gdb.go/package.exp
index 53b0617f08..cb181c7728 100644
--- a/gdb/testsuite/gdb.go/package.exp
+++ b/gdb/testsuite/gdb.go/package.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile package1.go package2.go
 
diff --git a/gdb/testsuite/gdb.go/strings.exp b/gdb/testsuite/gdb.go/strings.exp
index d34498daa2..5da69a92f6 100644
--- a/gdb/testsuite/gdb.go/strings.exp
+++ b/gdb/testsuite/gdb.go/strings.exp
@@ -18,6 +18,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/types.exp b/gdb/testsuite/gdb.go/types.exp
index fedc377ca1..c8d7e21ac6 100644
--- a/gdb/testsuite/gdb.go/types.exp
+++ b/gdb/testsuite/gdb.go/types.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/gdb.go/unsafe.exp b/gdb/testsuite/gdb.go/unsafe.exp
index 89e2fff3c0..c1f625729c 100644
--- a/gdb/testsuite/gdb.go/unsafe.exp
+++ b/gdb/testsuite/gdb.go/unsafe.exp
@@ -20,6 +20,7 @@
 load_lib "go.exp"
 
 if { [skip_go_tests] } { continue }
+if { [support_go_compile] == 0 } { continue }
 
 standard_testfile .go
 
diff --git a/gdb/testsuite/lib/gdb.exp b/gdb/testsuite/lib/gdb.exp
index d5e2295703..d8ebddf63c 100644
--- a/gdb/testsuite/lib/gdb.exp
+++ b/gdb/testsuite/lib/gdb.exp
@@ -2490,6 +2490,18 @@ gdb_caching_proc support_complex_tests {
     } executable]
 }
 
+# Return 1 if compiling go is supported.
+gdb_caching_proc support_go_compile {
+
+    return [gdb_can_simple_compile go-hello {
+	package main
+	import "fmt"
+	func main() {
+	    fmt.Println("hello world")
+	}
+    } executable go]
+}
+
 # Return 1 if GDB can get a type for siginfo from the target, otherwise
 # return 0.
 
@@ -3631,7 +3643,14 @@ proc gdb_simple_compile {name code {type object} {compile_flags {}} {object obj}
             set postfix "s"
         }
     }
-    set src [standard_temp_file $name-[pid].c]
+    set ext "c"
+    foreach flag $compile_flags {
+	if { "$flag" == "go" } {
+	    set ext "go"
+	    break
+	}
+    }
+    set src [standard_temp_file $name-[pid].$ext]
     set obj [standard_temp_file $name-[pid].$postfix]
     set compile_flags [concat $compile_flags {debug nowarnings quiet}]
 